package me.zhengjie.modules.dm.daypc.rest;

import com.alibaba.fastjson.JSON;
import com.rabbitmq.client.BuiltinExchangeType;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import me.zhengjie.modules.dm.daypc.domain.DmDayPc;
import me.zhengjie.modules.dm.daypc.service.DmDayPcService;
import me.zhengjie.modules.dm.daypc.service.dto.DmDayPcDto;
import me.zhengjie.utils.ConnectionUtil;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.List;
import java.util.concurrent.TimeoutException;

@Component
public class SendMsg {
    @Autowired
    private AmqpTemplate amqpTemplate;
    @Autowired
    private DmDayPcService dmDayPcService;
    private static String isEable = "0";

    //每天10点执行
    @Scheduled(cron = "0 0 10 * * ?")
    //异步执行,指定线程池(配置类里配置)
    @Async("threadPoolTaskExecutor1")
    public void timer(){
        isEable = "1";
    }

    //每五分钟执行一次
    @Scheduled(cron = "0 */5 * * * ?")
    @Async("threadPoolTaskExecutor2")
    public void timer2(){
        if(isEable!=null&&isEable=="1"){
            send();
            isEable = "0";
        }
    }

    public void send(){
//        String msg = "Hello,rabbit";
        //获取连接
        Connection connection = ConnectionUtil.getConnection();
        try {
            List<DmDayPcDto> dmDayPc = dmDayPcService.queryAll(null);
            String userString = JSON.toJSONString(dmDayPc);
            Channel channel = connection.createChannel();
            String exchangeName = "schedule_produce";//交换机
            channel.exchangeDeclare(exchangeName, BuiltinExchangeType.DIRECT, true,false, null);
            String queue1Name = "schedule_produce";//队列名称
            channel.queueDeclare(queue1Name, true, false, false, null);
            channel.queueBind(queue1Name, exchangeName, "schedule_produce");// 队列绑定hello路由
            channel.basicPublish(exchangeName, "schedule_produce", null, userString.getBytes());
//            Boy boy=new Boy(15,"tom");
            //对象转化为字节码 把对象转化为字节码后，把字节码传输过去再转化为对象
//            byte[] bytes=getBytesFromObject(dmDayPc);
//            amqpTemplate.convertAndSend("exchange","topic.messages",bytes);

//            List<DmDayPcDto> dmDayPc = dmDayPcService.queryAll(null);
//            String userString = JSON.toJSONString(dmDayPc);
//            amqpTemplate.convertAndSend(exchangeName,queue1Name,userString);
            channel.close();
            connection.close();
        } catch (IOException | TimeoutException e) {
            e.printStackTrace();
        }
    }

    //对象转化为字节码
    public  byte[] getBytesFromObject(Serializable obj) throws Exception {
        if (obj == null) {
            return null;
        }
        ByteArrayOutputStream bo = new ByteArrayOutputStream();
        ObjectOutputStream oo = new ObjectOutputStream(bo);
        oo.writeObject(obj);
        return bo.toByteArray();
    }
}
